Wt: Wt::WTabWidget Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Wt::WTabWidget Class Reference

A widget that organizes contents in tab panes. More...

`#include <Wt/WTabWidget.h>`

Inheritance diagram for Wt::WTabWidget:
[legend]

## Public Member Functions
| WTabWidget ()
| Creates a new tab widget.
WMenuItem * | addTab (std::unique_ptr< WWidget > child, const WString &label, ContentLoading loadPolicy=ContentLoading::Lazy)
| Adds a new tab, with child as content, and the given label.
WMenuItem * | insertTab (int index, std::unique_ptr< WWidget > child, const WString &label, ContentLoading loadPolicy=ContentLoading::Lazy)
| Inserts a new tab, with child as content, and the given label.
std::unique_ptr< WWidget > | removeTab (WWidget *widget)
| Removes a tab item.
int | count () const
| Returns the number of tabs.
WWidget * | widget (int index) const
| Returns the content widget at the given tab index.
WMenuItem * | itemAt (int index) const
| Returns the item at the given tab index.
int | indexOf (WWidget *widget) const
| Returns the index of the tab of the given content widget.
void | setCurrentIndex (int index)
| Activates the tab at index.
int | currentIndex () const
| Returns the index of the activated tab.
void | setCurrentWidget (WWidget *widget)
| Activates the tab showing the given widget
WWidget * | currentWidget () const
| Returns the widget of the activated tab.
WMenuItem * | currentItem () const
| Returns the item of the activated tab.
void | setTabEnabled (int index, bool enable)
| Enables or disables a tab.
bool | isTabEnabled (int index) const
| Returns whether a tab is enabled.
void | setTabHidden (int index, bool hidden)
| Hides or shows a tab.
bool | isTabHidden (int index) const
| Returns whether a tab is hidden.
void | setTabCloseable (int index, bool closeable)
| Make it possible to close a tab interactively or by closeTab.
bool | isTabCloseable (int index)
| Returns whether a tab is closeable.
void | setTabText (int index, const WString &label)
| Changes the label for a tab.
WString | tabText (int index) const
| Returns the label for a tab.
void | setTabToolTip (int index, const WString &tip)
| Sets the tooltip for a tab.
WString | tabToolTip (int index) const
| Returns the tooltip for a tab.
void | setInternalPathEnabled (const std::string &basePath="")
| Enables internal paths for items.
bool | internalPathEnabled () const
| Returns whether internal paths are enabled.
void | setInternalBasePath (const std::string &path)
| Sets the internal base path.
const std::string & | internalBasePath () const
| Returns the internal base path.
Signal< int > & | currentChanged ()
| Signal emitted when the user activates a tab.
void | closeTab (int index)
| Closes a tab at `index`.
Signal< int > & | tabClosed ()
| Signal emitted when the user closes a tab.
WStackedWidget * | contentsStack () const
| Returns the contents stack.
void | setOverflow (Overflow overflow, WFlags< Orientation > orientation=(Orientation::Horizontal|Orientation::Vertical))
| Sets how overflow of contained children must be handled.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that organizes contents in tab panes.

This widget combines a horizontal WMenu with a WStackedWidget, and a tab-like look.

A tab widget will place the tab bar on top of the contents, and fit the contents below it.

Usage example:

Wt::WTabWidget *examples = addWidget(std::make_unique<Wt::WTabWidget>());
examples->addTab(helloWorldExample(), "Hello World");
examples->addTab(chartExample(), "Charts");
examples->addTab(std::make_unique<Wt::WText>("A WText"), "WText");
examples->currentChanged().connect(this, &MyClass::logInternalPath);
examples->setInternalPathEnabled();
examples->setInternalBasePath("/examples");
Wt::Signal::connect
virtual Wt::Signals::connection connect(WObject *target, WObject::Method method) override
Connects to a slot.
Definition WSignal.h:730
Wt::WTabWidget
A widget that organizes contents in tab panes.
Definition WTabWidget.h:70
Wt::WTabWidget::setInternalBasePath
void setInternalBasePath(const std::string &path)
Sets the internal base path.
Wt::WTabWidget::setInternalPathEnabled
void setInternalPathEnabled(const std::string &basePath="")
Enables internal paths for items.
Wt::WTabWidget::currentChanged
Signal< int > & currentChanged()
Signal emitted when the user activates a tab.
Definition WTabWidget.h:224
Wt::WTabWidget::addTab
WMenuItem * addTab(std::unique_ptr< WWidget > child, const WString &label, ContentLoading loadPolicy=ContentLoading::Lazy)
Adds a new tab, with child as content, and the given label.

### CSS

The tab widget is styled by the current CSS theme.

An example WTabWidget (default) | An example WTabWidget (polished)

## Member Function Documentation

## ◆ addTab()

WMenuItem * Wt::WTabWidget::addTab | ( | std::unique_ptr< WWidget > | child,
|  | const WString & | label,
|  | ContentLoading | loadPolicy = ContentLoading::Lazy )

Adds a new tab, with child as content, and the given label.

Returns the menu item that implements the tab item.

## ◆ closeTab()

void Wt::WTabWidget::closeTab | ( | int | index | ) |

Closes a tab at `index`.

A tab that has been closed is marked as hidden, but not removed from the menu.

See also
  removeTab(), setTabHidden()

## ◆ contentsStack()

WStackedWidget * Wt::WTabWidget::contentsStack | ( |  | ) | const

Returns the contents stack.

The tab widget is implemented as a WMenu + WStackedWidget which displays the contents. This method returns a reference to this contents stack.

## ◆ currentChanged()

Signal< int > & Wt::WTabWidget::currentChanged | ( |  | ) |

Signal emitted when the user activates a tab.

The index of the newly activated tab is passed as an argument.

## ◆ indexOf()

int Wt::WTabWidget::indexOf | ( | WWidget * | widget | ) | const

Returns the index of the tab of the given content widget.

If the widget is not in this tab widget, then -1 is returned.

## ◆ insertTab()

WMenuItem * Wt::WTabWidget::insertTab | ( | int | index,
|  | std::unique_ptr< WWidget > | child,
|  | const WString & | label,
|  | ContentLoading | loadPolicy = ContentLoading::Lazy )

Inserts a new tab, with child as content, and the given label.

Returns the menu item that implements the tab item.

## ◆ internalBasePath()

const std::string & Wt::WTabWidget::internalBasePath | ( |  | ) | const

Returns the internal base path.

The default value is the application's internalPath (WApplication::internalPath()) that was recorded when setInternalPathEnabled() was called, and together with each WMenuItem::pathComponent() determines the paths for each item.

For example, if internalBasePath() is `"/examples/"` and pathComponent() for a particular item is `"charts/"`, then the internal path for that item will be `"/examples/charts/"`.

See also
  setInternalPathEnabled()

## ◆ internalPathEnabled()

bool Wt::WTabWidget::internalPathEnabled | ( |  | ) | const

Returns whether internal paths are enabled.

See also
  setInternalPathEnabled()

## ◆ isTabCloseable()

bool Wt::WTabWidget::isTabCloseable | ( | int | index | ) |

Returns whether a tab is closeable.

See also
  setTabCloseable()

## ◆ isTabEnabled()

bool Wt::WTabWidget::isTabEnabled | ( | int | index | ) | const

Returns whether a tab is enabled.

See also
  WMenu::enableItem(), WMenu::disableItem()

## ◆ removeTab()

std::unique_ptr< WWidget > Wt::WTabWidget::removeTab | ( | WWidget * | widget | ) |

Removes a tab item.

See also
  WMenu::removeItem()

## ◆ setInternalBasePath()

void Wt::WTabWidget::setInternalBasePath | ( | const std::string & | path | ) |

Sets the internal base path.

A '/' is appended to turn it into a folder, if needed.

See also
  setInternalPathEnabled(), internalBasePath()

## ◆ setInternalPathEnabled()

void Wt::WTabWidget::setInternalPathEnabled | ( | const std::string & | basePath = "" | ) |

Enables internal paths for items.

The menu participates in the internal path by changing the internal path when an item has been selected, and listening for path changes to react to path selections. As a consequence this allows the user to bookmark the current menu selection and revisit it later, use back/forward buttons to navigate through history of visited menu items, and allows indexing of pages.

For each menu item, WMenuItem::pathComponent() is appended to the `basePath`, which defaults to the internal path (WApplication::internalPath()). A '/' is appended to the base path, to turn it into a folder, if needed.

By default, menu interaction does not change the application internal path.

See also
  WMenuItem::setPathComponent().

## ◆ setTabCloseable()

void Wt::WTabWidget::setTabCloseable | ( | int | index,
|  | bool | closeable )

Make it possible to close a tab interactively or by closeTab.

A tab that has been closed is marked as hidden, but not removed from the menu.

See also
  removeTab()

## ◆ setTabEnabled()

void Wt::WTabWidget::setTabEnabled | ( | int | index,
|  | bool | enable )

Enables or disables a tab.

Enables or disables the tab at `index`. A disabled tab cannot be activated.

## ◆ setTabHidden()

void Wt::WTabWidget::setTabHidden | ( | int | index,
|  | bool | hidden )

Hides or shows a tab.

Hides or shows the tab at `index`.

## ◆ setTabToolTip()

void Wt::WTabWidget::setTabToolTip | ( | int | index,
|  | const WString & | tip )

Sets the tooltip for a tab.

The tooltip is shown when the user hovers over the label.

## ◆ tabClosed()

Signal< int > & Wt::WTabWidget::tabClosed | ( |  | ) |

Signal emitted when the user closes a tab.

The index of the closed tab is passed as an argument.

See also
  closeTab(), setTabCloseable()

## ◆ tabText()

WString Wt::WTabWidget::tabText | ( | int | index | ) | const

Returns the label for a tab.

See also
  setTabText()

## ◆ tabToolTip()

WString Wt::WTabWidget::tabToolTip | ( | int | index | ) | const

Returns the tooltip for a tab.

See also
  setTabToolTip()